REM THIS IS THE PROGRAM 'OPT'
REM THE PURPOSE OF THIS PROGRAM OPTIMAL ALLOCATION OF SEARCH EFFORT AMONG
REM SEVERAL PROBABILITY CELLS
REM 
REM PROGRAM WRITTEN BY COMMANDER DISCENZA USCG 7/12/78
REM REF CHARNES+COOPER "THE OPTIMUM DISTRIBUTION OF EFFORT",
REM MANAGEMENT SCIENCE, 1958.
REM REF STONE'S "THEORY OF OPTIMAL SEARCH"; ACADEMIC PRESS 1975
REM
	DIM LP(10)
	INPUT "ENTER THE NUMBER OF CELLS";NCELL
	PRINT "NOW ENTER THE SORTED PROBABILITY OF TARGET FOR ";NCELL;"CELLS"
	PRINT "LIST THE GREATEST FIRST, AND THE LEAST POT-CELL LAST"
	PRINT "ENTER THESE POT'S IN PERCENT"
	FOR I=1 TO NCELL
		PRINT "FOR CELL NUMBER ";I;
		INPUT "THE POT IS";PI
		IF PI>0 THEN LP(I)=LOG(PI/100)
	NEXT I
REM
REM ******************************************************************
REM
REM WHAT IS THE SEARCH FORCE AVAILABLE?
REM EF(FOR EACH SATTELITE BASE)=(SWEEP WIDTH)X(NUMBER OF A/C)X(AVE A/C SPEED)X
REM			X(HOURS A/C CAN SEARCH)/(AREA OF ONE SEARCH CELL)
REM
5	PRINT "ENTER EFFORTS, 0 TO END"
	TOTEF=0:NACFT=0
10	INPUT EF
	IF EF<>0 THEN TOTEF=TOTEF+EF:NACFT=NACFT+1:GOTO 10
	IF NACFT=0 THEN STOP
	PRINT NACFT;" AIRCRAFT ENTERED WITH A TOTAL EFFECTIVE FORCE OF ";TOTEF
REM
REM ************************************************************************
REM
REM APPORTION AVAILABLE EFFORT
REM
	EFF=0
	FOR I=1 TO NCELL
		EFF=EFF+(LP(I)-LP(I+1))*I
		IF EFF>TOTEF THEN GOTO 30
	NEXT I
30	BSTAR=LP(I+1)+(EFF-TOTEF)/I
	FOR I=1 TO NCELL
		IF LP(I)>BSTAR THEN COV=LP(I)-BSTAR ELSE COV=0
		PRINT "FOR CELL NUMBER ";I;
		PRINT ",EST POT WAS=";INT(.5+100*EXP(LP(I)));"%,";
		PRINT "AND OPT POD=";INT(1000*(1-EXP(-COV)))/10;"%"
	NEXT I
	GOTO 5				REM TRY AGAIN WITH CHANGED FORCES
