REM			THIS IS THE PROGRAM 'VISPOD'
REM		WRITTEN BY CAPT R.A.GREGOIRE CAP PAWG GROUP 30
REM
PRINT "-THIS PROGRAM CALCULATES TABLES OF VISUAL SEARCH POD'S"
INPUT "WHAT IS THE SMALLEST TRACK SPACING";SM
INPUT "WHAT IS THE LARGEST TRACK SPACING";LR
INPUT "WHAT IS THE TRACK SPACING INCREMENT";X1
REM
DIM C(5,5), T(4), T$(4), A$(5),VI$(5),P(5)
REM EQUATION CONSTANTS FOLLOW-FORMAT C(ALTITUDE #, CONSTANT #)
REM FOR 200 FT
DATA-3.438060E-02,.2050731,-1.006933E-02,-5.605945E-04,-6.269870E-05
REM FOR 300 FT
DATA .4948905, -.7147783, .535268, -.12496, 9.579662E-03
REM FOR 500 FT
DATA .6070413, -.924985, .7044575, -.1699153, 1.340136E-02
REM FOR 700 FT
DATA .7330137, -1.134626, .8355327,-.1996037,1.568362E-02
REM FOR 1000FT
DATA .4649629, -.5862799, .4975626, -.1146642, 8.416611E-03
REM TERRAIN FACTORS
DATA 1.0,.5,.25,.15
REM TERRAIN TYPE
DATA "OPEN COVER","MODERATE COVER","HEAVY COVER","ROCK OR SNOW COVER"
REM SEARCH ALTITUDE
DATA "200 FT","300 FT","500 FT","700 FT","1000 FT"
REM TABLE COLUMN HEADINGS
DATA " 1 NM"," 2 NM"," 3 NM"," 4 NM"," 5 NM"
REM
REM READ C'S EQUATION CONSTANTS
FOR I=1 TO 5:FOR J=1 TO 5:READ C(I,J):NEXT J: NEXT I
REM READ T'S TERRAIN FACTORS
FOR I=1 TO 4:READ T(I):NEXT I
REM READ T$'S TERRAIN TYPES
FOR I=1 TO 4:READ T$(I):NEXT I
REM READ A$'S ALTITUDES
FOR I=1 TO 5:READ A$(I):NEXT I
REM READ VI$'S VISIBILITIES
FOR I=1 TO 5:READ VI$(I):NEXT I
PRINT CHR$(12):PRINT:PRINT:PRINT CHR$(12)
REM PROGRAM BEGINS HERE
REM TERRAIN LOOP
FOR T1=1 TO 4
  REM SEARCH ALTITUDE LOOP
  FOR A1=1 TO 5
  PRINT:PRINT
  PRINT TAB(14);"THIS POD TABLE IS FOR ";T$(T1);" TERRAIN"
  PRINT TAB(23);A$(A1);" SEARCH ALTITUDE"
  PRINT
  PRINT TAB(26);"SEARCH VISIBILITY"
  PRINT "SPACING";TAB(14);VI$(1);TAB(26);VI$(2);TAB(38);\
  VI$(3);TAB(50);VI$(4);TAB(62);VI$(5)
  PRINT "-------";TAB(14);"------";TAB(26);"------";TAB(38);\
        "------";TAB(50);"------";TAB(62);"------"
  PRINT
    REM TRACK SPACING LOOP
    FOR S=SM TO LR STEP X1
      S=(INT(1000*S+.5))/1000
      REM VISIBILITY LOOP
      FOR V=1 TO 5
      REM
      REM MAIN CALCULATION ROUTINE
      INT1=C(A1,3)+V*(C(A1,4)+V*C(A1,5))
      W=C(A1,1)+V*(C(A1,2)+V*INT1)
      COV=T(T1)*W/S
      P(V)=(INT(1000*(1-EXP(-COV))+.5))/10
      NEXT V
      PRINT S;TAB(7);"NM";TAB(14);P(1);"%";TAB(26);P(2); \
      "%";TAB(38);P(3);"%";TAB(50);P(4);"%";TAB(62);P(5);"%"
    NEXT S
  PRINT CHR$(12):REM NEW PAGE FOR NEW TABLE
  NEXT A1:REM NEXT SEARCH ALTITUDE
NEXT T1:REM NEXT TERRAIN FACTOR
STOP
END
